<!DOCTYPE html>
<html lang="en">
  <head>
    <title>
      Task 390.10 Jquery - Button Data - button click event handlers
    </title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>

  <body onload="onPageLoad()">
    <h1>Jquery: button data and click handlers</h1>
    <button id="btn-user-data" class="btn btn-primary">Dữ liệu User</button>
    <button id="btn-car-data" class="btn btn-secondary">Dữ liệu Ô tô</button>
  </body>
  ​
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm xử lý sự kiện tải trang
    function onPageLoad() {
      // xử lý nút động: User Data
      // 1) Dữ liệu đi kèm nút
      // 2) Hàm xử lý click

      //user data button 1. gán dữ liệu cho nút userdata
      addDataToUserButton();
      //user data button 2. gán hàm xử lý sự kiện cho nút user data
      addEventClickToUserDataButton();

      //car data button 1. gán dữ liệu cho nút cardata
      addDataToCarButton();
      //car data button 2. gán hàm xử lý sự kiện cho nút car data
      addEventClickToCarDataButton();
    }
    // hàm xử lý sự kiện nút UserData click
    function onBtnUserDataClick(paramUserDataButton) {
      console.log("Nút UserData được ấn ....!");
      var vUserId = $(paramUserDataButton).data("userid"); //tạo jquery element từ dom, và lấy data
      var vUserName = $(paramUserDataButton).data("username");

      console.log("Userid: " + vUserId);
      console.log("UserName: " + vUserName);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // gán dữ liệu cho nút User Data
    function addDataToUserButton() {
      $("#btn-user-data")
        .data("userid", "NgaNT") //gán data vào nút
        .data("username", "Nguyễn Thị Nga");
    }

    // hàm gán sự kiện cho các nút detail
    function addEventClickToUserDataButton() {
      $("#btn-user-data").on("click", function () {
        // gán hàm xử lý click
        onBtnUserDataClick(this); //tham số this = nút này (DOM button)
      });
    }

    // hàm xử lý sự kiện nút CarData click
    function onBtnCarDataClick(paramCarDataButton) {
      console.log("Nút CarData được ấn ....!");
      var vCarId = $(paramCarDataButton).data("carid"); //tạo jquery element từ dom, và lấy data
      var vCarName = $(paramCarDataButton).data("carname");
      var vYear = $(paramCarDataButton).data("year");

      console.log("carid: " + vCarId);
      console.log("carname: " + vCarName);
      console.log("year: " + vYear);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // gán dữ liệu cho nút User Data
    function addDataToCarButton() {
      $("#btn-car-data")
        .data("carid", "Toyo") //gán data vào nút
        .data("carname", "toyota")
        .data("year", "2016");
    }

    // hàm gán sự kiện cho các nút detail
    function addEventClickToCarDataButton() {
      $("#btn-car-data").on("click", function () {
        // gán hàm xử lý click
        onBtnCarDataClick(this); //tham số this = nút này (DOM button)
      });
    }
  </script>
</html>
​

